SketchMorph subclass: #WebCamMorph
	instanceVariableNames: 'handle '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebCam-Win32'!

!WebCamMorph methodsFor: 'initialize-release' stamp: 'WJB 5/9/2001 10:54'!
connectDevice:device
	handle _ self apiStartCamera: (self apiFindWindow: 'SqueakWindowClass' with: 0) with:device.
	handle = 0 ifTrue:[self delete].
	self form:(Form extent:(self apiGetImageSize:handle) asPoint depth:32).! !

!WebCamMorph methodsFor: 'initialize-release' stamp: 'WJB 5/8/2001 21:09'!
delete
	self  apiDestroyWindow: handle.
	super delete.
! !

!WebCamMorph methodsFor: 'initialize-release' stamp: 'WJB 5/8/2001 23:25'!
initialize
	super initialize.
	self selectDevice.
	self form:(Form extent:0@0)! !

!WebCamMorph methodsFor: 'initialize-release' stamp: 'WJB 5/8/2001 23:14'!
selectDevice
	| menu name version |
	name _ ByteArray new: 60.
	version _ ByteArray new: 60.
	menu _ MenuMorph entitled:'Choose a device'.
	0
		to: 9
		do: [:index | (self
					apiCapGetDriverDescription: index
					with: name
					with: name size
					with: version
					with: version size)
				ifTrue: [menu
						add: name asString
						target:self
						selector: #connectDevice:
						argument: index]].
	menu addLine.
	menu add:'cancel' target:self selector:#delete.
	menu openInWorld; center:Sensor cursorPoint.! !


!WebCamMorph methodsFor: 'stepping' stamp: 'WJB 5/9/2001 15:18'!
step
	handle ifNotNil:[
	self
		apiSendMessage: handle
		with: self capGrabFrame 
		with: 0
		with: 0.
	self apiGetBits: originalForm bits.
	self layoutChanged].
	! !

!WebCamMorph methodsFor: 'stepping' stamp: 'WJB 5/8/2001 21:10'!
stepTime
	^0! !


!WebCamMorph methodsFor: 'accessing' stamp: 'WJB 5/9/2001 00:20'!
getCopy
	^SketchMorph new form:self form deepCopy; position:self position! !

!WebCamMorph methodsFor: 'accessing' stamp: 'WJB 5/8/2001 21:09'!
handle
	^handle! !

!WebCamMorph methodsFor: 'accessing' stamp: 'WJB 5/9/2001 00:01'!
test
	self apiSendMessage: handle with:  self capDlgVideoFormat with: 0 with: 0.
	self form:(Form extent:(self apiGetImageSize:handle) asPoint depth:32).! !


!WebCamMorph methodsFor: 'flags' stamp: 'WJB 5/8/2001 21:58'!
capDlgVideoFormat 
	^16r400 + 41! !

!WebCamMorph methodsFor: 'flags' stamp: 'WJB 5/9/2001 14:58'!
capDlgVideoSource 
	^16r400 + 42! !

!WebCamMorph methodsFor: 'flags' stamp: 'WJB 5/8/2001 21:09'!
capGrabFrame
	^16r400 + 60! !


!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/9/2001 15:09'!
apiCapGetDriverDescription:drvNo with:drvName with:nameLen with:drvVer with:verLen
	"Fills drvName and drvVer with the name and version of the driver at drvNo"
	<apicall: bool 'capGetDriverDescriptionA' (long char* long char* long) module: 'avicap32.dll'>
	^ self externalCallFailed! !

!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/9/2001 15:10'!
apiDestroyWindow: window 
	"Closes the (hidden) capture window, thereby also disconnecting the driver."
	<apicall: bool 'DestroyWindow' (long) module: 'user32.dll'>
	^ self externalCallFailed! !

!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/9/2001 15:12'!
apiFindWindow: class with: name 
	"Get a handle to the Windows class name. For squeak name should be: 'SqueakWindowClass'"
	<apicall: long 'FindWindowA' (char* long) module: 'user32.dll'>
	^ self externalCallFailed! !

!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/9/2001 15:13'!
apiGetBits:bits
	"Fills bits with data captured by the video drivers"
	<apicall: bool 'GetBits' (void *) module: 'sqWebCam.dll'>
	^ self externalCallFailed! !

!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/8/2001 21:09'!
apiGetImageSize
	"Return the HWND currently having the input focus"
	<apicall: Win32Point 'GetImageSize' (void) module: 'test.dll'>
	^ self externalCallFailed! !

!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/9/2001 15:13'!
apiGetImageSize:hwnd
	"Get the new size of the window hwnd"
	<apicall: Win32Point 'GetImageSize' (long) module: 'sqWebCam.dll'>
	^ self externalCallFailed! !

!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/9/2001 15:15'!
apiSendMessage: window with: message with: param1 with: param2 
	"Send a message to a window"
	<apicall: long 'SendMessageA' (long long long long) module: 'user32.dll'>
	^ self externalCallFailed! !

!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/8/2001 22:07'!
apiStartCamera:hwnd
	"Return the HWND currently having the input focus"
	<apicall: long 'StartCamera' (long) module: 'test.dll'>
	^ self externalCallFailed! !

!WebCamMorph methodsFor: 'api calls' stamp: 'WJB 5/9/2001 15:17'!
apiStartCamera:hwnd with:device
	"Add a capture window to hwnd ans start capturing data from device"
	<apicall: long 'StartCamera' (long long) module: 'sqWebCam.dll'>
	^ self externalCallFailed! !


!WebCamMorph methodsFor: 'other' stamp: 'WJB 5/9/2001 14:58'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'WEBCAM - set video format' action: #openVideoFormatBox.
	aCustomMenu add: 'WEBCAM - set video source' action: #openVideoSourceBox.

! !

!WebCamMorph methodsFor: 'other' stamp: 'WJB 5/9/2001 15:17'!
duplicateMorph: evt
	"Make and return a (static) duplicate of myself"
	| dup |
	dup _ SketchMorph new form:self form deepCopy; position:self position.
	evt hand grabMorph: dup from: owner. "duplicate was ownerless so use #grabMorph:from: here"
	^dup! !

!WebCamMorph methodsFor: 'other' stamp: 'WJB 5/9/2001 14:53'!
openVideoFormatBox
	self apiSendMessage: handle with:  self capDlgVideoFormat with: 0 with: 0.
	self form:(Form extent:(self apiGetImageSize:handle) asPoint depth:32).! !

!WebCamMorph methodsFor: 'other' stamp: 'WJB 5/9/2001 15:01'!
openVideoSourceBox
	self apiSendMessage: handle with:  self capDlgVideoSource with: 0 with: 0! !


WebCamMorph subclass: #WebCamBallMouseMorph
	instanceVariableNames: 'morph flag '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebCam-Win32'!

!WebCamBallMouseMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 15:55'!
addOptionalHandlesTo: aHalo box: box 
	super addOptionalHandlesTo: aHalo box: box.
	(aHalo
		addHandleAt: box rightCenter
		color: Color blue
		icon: 'Halo-Paint'
		on: #mouseDown
		send: #getColor
		to: self)
	! !

!WebCamBallMouseMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 16:19'!
getColor
	Cursor crossHair
		showWhile: [[Sensor redButtonPressed] whileTrue.
			[Sensor redButtonPressed]
				whileFalse: [World doOneCycle].
			self color: (Display colorAt: Sensor cursorPoint)]! !

!WebCamBallMouseMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 16:06'!
grabMeAMorph
	"Return the morph to grab from a mouse down event. If none, return nil. "
	World
		submorphsDo: [:m | (m fullContainsPoint: self position)
				ifTrue: [m == self
						ifFalse: [^ m]]].
	^ nil! !

!WebCamBallMouseMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 15:54'!
initialize
	super initialize.
	flag _ 0.! !

!WebCamBallMouseMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 16:27'!
step
	| AVX AVY DIV VARX VARY pos |
	super step.
	AVX _ AVY _ DIV _ VARX _ VARY _ 0.
	1
		to: originalForm height
		by: 4
		do: [:y | 1
				to: originalForm width
				by: 4
				do: [:x | (self color
							diff: (originalForm colorAt: x @ y))
							< 0.1
						ifTrue: [AVX _ AVX + x.
							AVY _ AVY + y.
							DIV _ DIV + 1.
							VARX _ VARX + (AVX / DIV - x) abs.
							VARY _ VARY + (AVY / DIV - y) abs]]].
	World submorphs first == self
		ifFalse: [owner = ActiveHand ifFalse:[World addMorphFront: self]].
	DIV = 0
		ifFalse: [VARX / (VARY + 1) > 1.3
				ifTrue: [morph isNil
						ifTrue: [morph _ self grabMeAMorph.
							morph notNil
								ifTrue: [flag _ flag + 1.
									flag = 5
										ifTrue: [self addMorph: morph]
										ifFalse: [morph _ nil]]]]
				ifFalse: [morph notNil
						ifTrue: [flag _ flag - 1.
							flag = 0
								ifTrue: [World addMorph: morph.
									morph _ nil]]].
			pos _ (Display width - (Display width / originalForm width * (AVX // DIV)) @ (Display height / originalForm height * (AVY // DIV))) rounded.
			self position: self position * 5 + pos // 6]! !


WebCamMorph subclass: #WebCamBounceMorph
	instanceVariableNames: 'ball velocity '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebCam-Win32'!

!WebCamBounceMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/10/2001 00:54'!
addOptionalHandlesTo: aHalo box: box 
	super addOptionalHandlesTo: aHalo box: box.
	(aHalo
		addHandleAt: box rightCenter
		color: Color blue
		icon: 'Halo-Paint'
		on: #mouseDown
		send: #getColor
		to: self)
	! !

!WebCamBounceMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 23:59'!
delete
	ball delete.
	super delete! !

!WebCamBounceMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/10/2001 00:54'!
getColor
	Cursor crossHair
		showWhile: [[Sensor redButtonPressed] whileTrue.
			[Sensor redButtonPressed]
				whileFalse: [World doOneCycle].
			self color: (Display colorAt: Sensor cursorPoint)]! !

!WebCamBounceMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 23:31'!
initialize
	super initialize.
	velocity _ 0.
	shift _ 0@0.
	ball _ EllipseMorph new openInWorld! !

!WebCamBounceMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/10/2001 00:40'!
reposition: point 
	point y < self top
		ifTrue: [^ 0].
	self top
		to: point y
		do: [:num | ((originalForm colorAt: point x - self left @ (num - self top))
					diff: self color)
					< 0.2
				ifTrue: [^ point y - num]].
	^ 0! !

!WebCamBounceMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/10/2001 00:51'!
step
	| tmp |
	super step.
	ball owner = ActiveHand
		ifFalse: [
			World submorphs first == ball
		ifFalse: [World addMorphFront: ball].
			ball position: ball position + (0 @ velocity).
			velocity _ velocity + 1.
			tmp _ self reposition: ball center x @ ball bottom.
			tmp > 0
				ifTrue: [
					ball position: ball position - (0@tmp).
					velocity > 0
						ifTrue: [velocity _ 0 - (velocity) // 2]
						ifFalse: [velocity _ velocity - (tmp // 2)]].
			ball bottom > self bottom
				ifTrue: [ball bottom: self bottom.
					velocity _ 0 - (velocity // 2)]]! !


WebCamMorph subclass: #WebCamGuardMorph
	instanceVariableNames: 'limit '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebCam-Win32'!

!WebCamGuardMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 17:28'!
step
	| f dif |
	f _ originalForm deepCopy.
	super step.
	dif _ 0.
	1
		to: originalForm height
		by: 4
		do: [:y | 1
				to: originalForm width
				by: 4
				do: [:x | 
					dif _ dif + ((f colorAt: x @ y) diff: (originalForm colorAt: x @ y))]].
	limit isNil ifTrue:[limit _ dif].
	dif > (limit * 2) ifTrue:[SampledSound playSoundNamed: 'croak'].
	limit _ (limit + dif) / 2

							! !


WebCamMorph subclass: #WebCamMouseMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebCam-Win32'!

!WebCamMouseMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 15:43'!
addOptionalHandlesTo: aHalo box: box 
	super addOptionalHandlesTo: aHalo box: box.
	(aHalo
		addHandleAt: box rightCenter
		color: Color blue
		icon: 'Halo-Paint'
		on: #mouseDown
		send: #getColor
		to: self)
	! !

!WebCamMouseMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 16:20'!
getColor
	Cursor crossHair
		showWhile: [[Sensor redButtonPressed] whileTrue.
			[Sensor redButtonPressed]
				whileFalse: [World doOneCycle].
			self color: (Display colorAt: Sensor cursorPoint)]! !

!WebCamMouseMorph methodsFor: 'as yet unclassified' stamp: 'WJB 5/9/2001 15:47'!
step
	"Follow anything that's my color across the screen"
	| AVX AVY DIV pos |
	super step.
	AVX _ AVY _ DIV _ 0.
	1
		to: originalForm height
		by: 4
		do: [:y | 1
				to: originalForm width
				by: 4
				do: [:x | (self color
							diff: (originalForm colorAt: x @ y))
							< 0.1
						ifTrue: [AVX _ AVX + x.
							AVY _ AVY + y.
							DIV _ DIV + 1]]].
	DIV = 0
		ifFalse: [pos _ (Display width - (Display width / originalForm width * (AVX // DIV)) @ (Display height / originalForm height * (AVY // DIV))) rounded.
			self position: self position * 2 + pos // 3]! !

